import java.io.*;
import javafx.scene.image.Image;
import javafx.application.Application;

/**
 * イメージクラス
 */
public class KImage {

	/** アプリケーション */
	private static Application application = null;

	/**
	 * アプリケーション設定
	 * <pre>
	 * ファイルパスを取得するために、アプリケーションクラスを設定します。
	 * </pre>
	 * @param application アプリケーション
	 */
	public static void setApplication(Application application){
		KImage.application = application;
	}

	/**
	 * イメージをファイルから取り込む
	 * @param fileName Imgaeのファイル名
	 * @return Image 読み込んだイメージ
	 * @throws IOException ファイルを読み込み中にエラーが発生した場合
	 */
	public static Image getImage(String fileName) {

		// InputStreamを生成
		InputStream is = KImage.application.getClass().getResourceAsStream(fileName);

		// イメージを取り込む
		Image image = new Image(is);

		// 戻り値に読み込んだイメージをセット
		return image;

	} // getImage

}
