import java.util.*;
import javafx.scene.image.Image;
import javafx.scene.Node;

/**
 * ビーム２
 */
public class KSpriteBeam2 extends KSprite implements KConstant {

	private		int		mX		= 0;
	private		int		mY		= 12;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageBeam2_L = null;
		Image imageBeam2_R = null;

		imageBeam2_L = KImage.getImage("image\\imageBeam2_L.gif");
		imageBeam2_R = KImage.getImage("image\\imageBeam2_R.gif");

		KSpriteBeam2.setImage(KSpriteBeam2.class, new Image[]{
			imageBeam2_L,
			imageBeam2_R
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteBeam2(KPanel panel, int mX, int mY){

		super(panel);

		this.mX = mX;
		this.mY = mY;

		super.setFitWidth(12);
		super.setFitHeight(12);

		// イメージ設定
		if(mX < 0){
			super.setImage(0);
		}else if(mX > 0){
			super.setImage(1);
		}else{
			throw new IllegalStateException("mXは０はだめです");
		}

	} // end

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		super.setLayoutX(super.getLayoutX() + mX);
		super.setLayoutY(super.getLayoutY() - mY);

		if(super.getLayoutY() < -32){
			super.removeSprite();
		}

		//
		// 判定
		//

		// 地面の層と敵の層のループ
		for(int i = 0; i < 2; i++){

			// スプライト層決定
			int layout = (i == 0)?LAYOUT_TEKI: LAYOUT_JIMEN_1;

			// スプライト一覧取得
			List<Node> spriteLst = panel.getSpriteLst(layout);

			// スプライト一覧の件数を取得
			int countSpriteLst = spriteLst.size();

			// スプライト一覧の件数分、ループ
			for(int j = 0; j < spriteLst.size(); j++){

				// スプライトを取得
				KSprite sprite = (KSprite)spriteLst.get(j);

				// nullの場合、
				if(sprite == null){
					// コンティニュー
					continue;
				}

				// 敵ではない場合、
				if(!(sprite instanceof KSpriteT00)){
					// コンティニュー
					continue;
				}

				// 敵にキャスト
				KSpriteT00 spriteT00 = (KSpriteT00)sprite;

				// 爆発している場合、
				if(spriteT00.isBomb()){
					// コンティニュー
					continue;
				}

				// 当たり判定しない場合、
				if(!spriteT00.isHanteiAtari()){
					// コンティニュー
					continue;
				}

				// XY取得
				double xT00 = spriteT00.getLayoutX();
				double yT00 = spriteT00.getLayoutY();

				// 敵が表示しきっていない場合、
				if(yT00 < 0){
					// コンティニュー
					continue;
				}

				// 大きさ取得
				double intWidthT00 = spriteT00.getWidth();
				double intHeightT00 = spriteT00.getHeight();

				double x = super.getLayoutX();
				double y = super.getLayoutY();

				// 当たり判定
				if(x < (xT00 + intWidthT00) && xT00 < (x + this.getWidth()) &&
								y < (yT00 + intHeightT00) && yT00 < (y + this.getHeight()) ){
					// 爆発
					spriteT00.bomb();
					// スプライト削除
					super.removeSprite();

				}

			} // end for スプライト一覧の件数分、ループ

		} // end for 地面の層と敵の層のループ

	} // end run

}
