import javafx.scene.image.Image;
import java.util.*;

/**
 * 地上物 64ドット 破壊可能
 * G11 CK-01 CK-01
 * G12 CK-02 CK-02
 */
public class KSpriteG11 extends KSpriteG00 implements KConstant {

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageG11 = null;
		Image imageG12 = null;

		imageG11 = KImage.getImage("image\\imageG11.gif");
		imageG12 = KImage.getImage("image\\imageG12.gif");

		KSpriteG11.setImage(KSpriteG11.class, new Image[]{
			imageG11,
			imageG12
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteG11(KPanel panel, double x, int image){

		super(panel);

		int tekiImage = -1;

		// 敵イメージを決定
		tekiImage = (image == G11)? 0: tekiImage;
		tekiImage = (image == G12)? 1: tekiImage;

		setImage(tekiImage);

		super.setLayoutX(x);
		super.setLayoutY(-128);

	} // end KSpriteG11

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// スーパークラスを呼び出す
		// 移動はスーパークラスで制御
		super.run();

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
