import javafx.scene.image.Image;
import java.util.*;

/**
 * トランジスタ／コンデンサ
 * G51 CA-TR1  TR-Tank
 * G52 CA-CDS1 CDS-Tank
 */
public class KSpriteG51 extends KSpriteG00 implements KConstant {

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageG51 = null;
		Image imageG52 = null;

		imageG51 = KImage.getImage("image\\imageG51.gif");
		imageG52 = KImage.getImage("image\\imageG52.gif");

		KSpriteG51.setImage(KSpriteG51.class, new Image[]{
			imageG51,
			imageG52
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteG51(KPanel panel, double x, int image){

		super(panel);

		int tekiImage = -1;

		// 敵イメージを決定
		tekiImage = (image == G51)? 0: tekiImage;
		tekiImage = (image == G52)? 1: tekiImage;

		setImage(tekiImage);

		super.setLayoutX(x);
		super.setLayoutY(-128);

	} // end KSpriteG51

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// スーパークラスを呼び出す
		// 移動はスーパークラスで制御
		super.run();

	}

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
