import javafx.scene.image.Image;
import java.util.*;

/**
 * 地上物 64ドット 回転物
 * G61 CA-PEN1 Penta-Base
 */
public class KSpriteG61 extends KSpriteG00 implements KConstant {

	private		int		time		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageG61_00 = null;
		Image imageG61_01 = null;
		Image imageG61_02 = null;
		Image imageG61_03 = null;

		imageG61_00 = KImage.getImage("image\\imageG61_00.gif");
		imageG61_01 = KImage.getImage("image\\imageG61_01.gif");
		imageG61_02 = KImage.getImage("image\\imageG61_02.gif");
		imageG61_03 = KImage.getImage("image\\imageG61_03.gif");

		KSpriteG61.setImage(KSpriteG61.class, new Image[]{
			imageG61_00,
			imageG61_01,
			imageG61_02,
			imageG61_03
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteG61(KPanel panel, double x){

		super(panel);

		super.setLayoutX(x);
		super.setLayoutY(-128);

	} // end KSpriteG61

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// スーパークラスを呼び出す
		// 移動はスーパークラスで制御
		super.run();

		// 爆発している場合、
		if(super.isBomb()){
			// リターン
			return;
		}

		// 時間＋１
		time++;

		// 0.1秒単位に
		if(time % 6 == 0){

			// イメージ計算
			int image = (time / 6) % 4;

			// イメージを変更する
			setImage(image);

		}

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
