import javafx.scene.image.Image;
import java.util.*;

/**
 * 128ドットCPU
 * G71 CA-JCN1 JCN Brain chip
 * G72 CA-SKK1 SKK Super Brain Chip
 */
public class KSpriteG71 extends KSpriteG00 implements KConstant {

	/** 被弾数 */
	private		int					hidan		= 0;

	/** 敵 */
	private		int					teki		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageG71 = null;
		Image imageG72 = null;

		imageG71 = KImage.getImage("image\\imageG71.gif");
		imageG72 = KImage.getImage("image\\imageG72.gif");

		KSpriteG71.setImage(KSpriteG71.class, new Image[]{
			imageG71,
			imageG72
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteG71(KPanel panel, double x, int image){

		super(panel);

		int tekiImage = -1;

		// 敵イメージを決定
		tekiImage = (image == G71)? 0: tekiImage;
		tekiImage = (image == G72)? 1: tekiImage;

		setImage(tekiImage);

		super.setLayoutX(x);
		super.setLayoutY(-128);

		this.teki = image;

	} // end KSpriteG71

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// スーパークラスを呼び出す
		// 移動はスーパークラスで制御
		super.run();

	}

	/**
	 * 爆発
	 */
	public void bomb(){

		// 被弾数＋１
		hidan++;

		// MPU かつ 被弾数が16未満の場合、
		// または
		// CPU かつ 被弾数が16未満の場合、
		if(teki == G71 && hidan < 4 || teki == G72 && hidan < 16){

			// 耐える音
			((KCtrlSKK)panel.getKCtrl()).startWaveTekiTaeru();

			// リターン
			return;
		}

		// 300点
		((KCtrlSKK)panel.getKCtrl()).addScore(300);

		super.bomb();

	} // end bomb

}
