import javafx.scene.image.Image;

/**
 * 敵０８ KK-PP ピカ
 */
public class KSpriteT08 extends KSpriteT00 implements KConstant {

	/** X方向移動量 */
	private		double		mX		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT08_00 = null;
		Image imageT08_01 = null;

		imageT08_00 = KImage.getImage("image\\imageT08_00.gif");
		imageT08_01 = KImage.getImage("image\\imageT08_01.gif");

		KSpriteT08.setImage(KSpriteT08.class, new Image[]{
			imageT08_00,
			imageT08_01
		});

	} // end initImage

	/**
	 * コンストラクタ
	 * @param panel KPanel
	 */
	public KSpriteT08(KPanel panel){

		super(panel);

		// X位置を設定
		super.setLayoutX(Math.random() * (WIDTH - getWidth()));

		super.setLayoutY(-getHeight());

		// X方向移動量を設定
		mX = 4 - Math.random() * 8;

	} // end KSpriteT08

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 親クラスは実行しない
		// 爆発する必要はないので、親クラスは呼び出さない

		// （コメントの上のコメント）
		// それなら、敵クラス（T00）を継承する必要もあるのか？
		// という疑問が浮かんでくるかもしれない。
		// 自機から見ると、敵だという扱いはしないといけないため。
		// KSpriteShipのrunメソッドで、T00に対して衝突の処理をしている。
		// そのため、敵クラス（T00）である必要があるのだ。

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 前進
		y = y + 12;

		x = x + mX;

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		// 雷のようなエネルギーの高いイメージを出すために、イメージを変更する。
		if(y > 396){
			setImage(KSpriteT08.class, 0);
		}else if(y > 360){
			setImage(KSpriteT08.class, 1);
		}else if(y > 156){
			setImage(KSpriteT08.class, 0);
		}else if(y > 120){
			setImage(KSpriteT08.class, 1);
		}

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		//
		// スーパーを呼び出さず、爆発させない
		//

		// T08吸い込み音スタート
		((KCtrlSKK)panel.getKCtrl()).startWaveT08Imbibe();

	} // end bomb

}
