import javafx.scene.image.Image;

/**
 * 敵０９ KK-N1 サイダー
 */
public class KSpriteT09 extends KSpriteT00 implements KConstant {

	private	final int	PHASE_1	= 1;
	private	final int	PHASE_2	= 2;

	/** フェーズ */
	private		int		phase	= PHASE_1;

	/** X方向移動量 */
	private		double	mX		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT09 = null;

		imageT09 = KImage.getImage("image\\imageT09.gif");

		KSpriteT09.setImage(KSpriteT09.class, imageT09);

	} // end initImage

	/**
	 * コンストラクタ
	 * @param panel KPanel
	 * @param x スプライトグループで表示位置を決定する
	 */
	public KSpriteT09(KPanel panel, double x){

		super(panel);

		super.setLayoutX(x);

		// 画面下から出現させる
		super.setLayoutY(HEIGHT);

	} // end KSpriteT09

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// 親クラスを実行する
		super.run();

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// フェーズ１の場合、
		if(phase == PHASE_1){

			// 前進
			y = y - 4;

			// 上まで登った場合、
			if(super.getLayoutY() <= 0){

				// フェーズ変更
				phase = PHASE_2;

				// X方向移動量計算
				x = super.getLayoutX();

				mX = (Math.random() * 10) * ((super.getLayoutX() == 0)?1: -1);

			} // end if 上まで登った場合

		// フェーズ２の場合、
		}else{

			// 前進
			y = y + 6;

			x = x + mX;

			// 画面の外に出た場合、
			if(y > HEIGHT){
				// スプライトを消す
				super.removeSprite();
			}

		} // end if フェーズ２の場合

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 200点
		((KCtrlSKK)panel.getKCtrl()).addScore(200);

		super.bomb();

	} // end bomb

}
