import javafx.scene.image.Image;

/**
 * 敵１１ KA-MD01 シンプルブラック
 */
public class KSpriteT11 extends KSpriteT00 implements KConstant {

	/** ビーム発射フラグ */
	private		boolean		flgBeam		= false;

	/** ビーム発射位置 */
	private		int			beamY		= -1;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT11 = null;

		imageT11 = KImage.getImage("image\\imageT11.gif");

		KSpriteT11.setImage(KSpriteT11.class, imageT11);

	} // end initImage

	/**
	 * コンストラクタ
	 * @param panel KPanel
	 * @param pos 編隊ポジション
	 * @param storyParam ビーム発射位置
	 */
	public KSpriteT11(KPanel panel, String storyParam){

		super(panel);

		// X位置：編隊ポジションを設定
		super.setLayoutX(Math.random() * (WIDTH - this.getWidth()));

		super.setLayoutY(-getHeight());

		// ビーム発射位置が設定されている場合、
		if(storyParam != null){
			beamY = Integer.parseInt(storyParam);
		}

	} // end KSpriteT11

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 親クラスを実行する
		super.run();

		double y = super.getLayoutY();

		// 前進
		y = y + 4;

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		super.setLayoutY(y);

		// ビームを発射する場合、
		if(!flgBeam && beamY != -1 && y > beamY){

			// ビーム発射
			flgBeam = true;

			KSpriteT99 spriteT99 = new KSpriteT99(super.getKPanel(), this, 2);
			super.getKPanel().addSprite(LAYOUT_TEKI, spriteT99);

		} // end if  ビームを発射する場合

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
