import java.util.*;
import javafx.scene.image.Image;
import javafx.scene.Node;

/**
 * 敵３３ KA-R03 レッド・アイ
 */
public class KSpriteT33 extends KSpriteT00 implements KConstant {

	/** 時間 */
	private		int			time		= 0;

	/** 画像パターン */
	private		int			pattern		= 0;

	/** X方向移動量 */
	private		double		mX 			= 0;

	/** Y方向移動量 */
	private		double		mY 			= 8f;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT33_00 = null;
		Image imageT33_01 = null;
		Image imageT33_02 = null;
		Image imageT33_03 = null;

		imageT33_00 = KImage.getImage("image\\imageT33_00.gif");
		imageT33_01 = KImage.getImage("image\\imageT33_01.gif");
		imageT33_02 = KImage.getImage("image\\imageT33_02.gif");
		imageT33_03 = KImage.getImage("image\\imageT33_03.gif");

		KSpriteT33.setImage(KSpriteT33.class, new Image[]{
			imageT33_00,
			imageT33_01,
			imageT33_02,
			imageT33_03,
			imageT33_02,
			imageT33_01
		});

	} // end initImage

	/**
	 * コンストラクタ
	 * @param panel KPanel
	 * @param storyParam ビーム発射間隔
	 */
	public KSpriteT33(KPanel panel){

		super(panel);

		// 自機を取得
		KSpriteShip spriteShip = ((KCtrlSKK)panel.getKCtrl()).getSpriteShip();

		double x = (WIDTH - this.getWidth()) * Math.random();
		double y = -getHeight();

		super.setLayoutX(x);
		super.setLayoutY(y);

		// 自機を追いかけるように移動量を計算
		mX = (spriteShip.getLayoutX() - x) / (spriteShip.getLayoutY() / mY);
		mX = (mX < -4f)?-4f: mX;
		mX = (mX > 4f)?4f: mX;

	} // end KSpriteT33

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 親クラスを実行する
		super.run();

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 前進
		y = y + mY;

		x = x + mX;

		// 生きている場合、
		if(!isBomb()){

			// 時間＋１
			time++;

			if(time % 4 == 0){

				pattern++;
				pattern = (pattern >= 6)?0: pattern;
				setImage(pattern);

			}

		}

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		super.setLayoutX(x);
		super.setLayoutY(y);

	}

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
