import java.util.*;
import javafx.scene.image.Image;
import javafx.scene.Node;

/**
 * 敵ミサイル
 */
public class KSpriteT99 extends KSprite implements KConstant {

	/** 移動量 */
	private		double		mX 		= 0d;
	private		double		mY 		= 0d;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT99 = null;

		imageT99 = KImage.getImage("image\\imageT99.gif");

		KSpriteT99.setImage(KSpriteT99.class, imageT99);

	} // end initImage

	/**
	 * コンストラクタ
	 * <pre>
	 * 通常パターンのビームです。
	 * </pre>
	 */
	public KSpriteT99(KPanel panel, KSprite sprite, int speed){

		super(panel);

		// 自機を取得
		KSpriteShip spriteShip = ((KCtrlSKK)panel.getKCtrl()).getSpriteShip();

		// 位置を設定
		double x = sprite.getLayoutX() + sprite.getWidth() / 2;
		double y = sprite.getLayoutY() + sprite.getHeight() / 2;

		double dx = spriteShip.getLayoutX() - x + spriteShip.getWidth() / 2;
		double dy = spriteShip.getLayoutY() - y + spriteShip.getHeight() / 2;

		// 距離を計算
		double dxdy = Math.sqrt(dx * dx + dy * dy);

		// 到達までの時間を取得
		double time = dxdy / speed;

		// XY方向の速さを取得
		mX = dx / time;
		mY = dy / time;

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end KSpriteT99

	/**
	 * コンストラクタ
	 * <pre>
	 * 方向を設定します。
	 * </pre>
	 */
	public KSpriteT99(KPanel panel, KSprite sprite, double mX, double mY){

		super(panel);

		// 位置を設定
		double x = sprite.getLayoutX();
		double y = sprite.getLayoutY();

		// XY方向の速さを取得
		this.mX = mX;
		this.mY = mY;

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end KSpriteT99

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 移動
		x = x + mX;
		y = y + mY;

		// 画面の外に出た場合、
		if(x < 0 || x > WIDTH || y < 0 || y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end run

}
