import javafx.scene.text.Text;
import javafx.scene.paint.Color;

/**
 * テキスト
 * <pre>
 * テキストを表示するオブジェクト。
 * Textを継承し、ほぼスーパークラスの機能を利用していますが、
 * 共通的な部分の設定を行います。
 * </pre>
 */
public class KText extends Text {

	/** パネル */
	protected KPanel panel = null;

	/**
	 * コンストラクタ
	 * @param panel パネル
	 * @param x 表示位置。X座標。
	 * @param y 表示位置。Y座標。
	 */
	public KText(KPanel panel, double x, double y){

		super(x, y, null);

		// パネルの保持
		this.panel = panel;

		// 色の設定
		super.setFill(Color.WHITE);

	} // end KText

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * </pre>
	 */
	public void run(){

	}

	/**
	 * パネル取得
	 */
	public KPanel getKPanel(){
		return panel;
	}

}
