import javafx.scene.text.Font;
import javafx.scene.paint.Color;

/**
 * Shield
 */
public class KTextShield extends KText {

	/** タイマー */
	private		int		timer		= 0;

	/** 色切替 */
	private		int		INTERVAL	= 8;

	/** 色 */
	private		Color[]	colors		= new Color[]{
										Color.rgb(255, 255,   0, 0.5),
										Color.rgb(240, 240,   0, 0.5),
										Color.rgb(224, 224,   0, 0.5),
										Color.rgb(208, 208,   0, 0.5),
										Color.rgb(192, 192,   0, 0.5),
										Color.rgb(160, 160,   0, 0.5),
										Color.rgb(128, 128,   0, 0.5),
										Color.rgb( 96,  96,   0, 0.5),
										Color.rgb( 64,  64,   0, 0.5),
										Color.rgb( 32,  32,   0, 0.5),
										Color.rgb(  0,   0,   0, 0.5),
										Color.rgb( 32,  32,   0, 0.5),
										Color.rgb( 64,  64,   0, 0.5),
										Color.rgb( 96,  96,   0, 0.5),
										Color.rgb(128, 128,   0, 0.5),
										Color.rgb(160, 160,   0, 0.5),
										Color.rgb(192, 192,   0, 0.5),
										Color.rgb(208, 208,   0, 0.5),
										Color.rgb(224, 224,   0, 0.5),
										Color.rgb(240, 240,   0, 0.5),
										Color.rgb(255, 255,   0, 0.5)
									};

	/** 色数 */
	private		int		ountColor	= colors.length;

	/**
	 * コンストラクタ
	 */
	public KTextShield(KPanel panel, double x, double y){

		super(panel, x, y);

	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// 時間＋１
		timer++;

		// 全ての色を使い終わったら、
		if(timer >= INTERVAL * ountColor){
			// 最初の色に戻す
			timer = 0;
		}

		// ダメージを受けている間の場合、
		if(timer < 0){

			// 赤色に変更
			super.setFill(Color.RED);

		// 色を変更するタイミングの場合、
		}else if(timer % INTERVAL == 0){

			// 色を変更する
			super.setFill(colors[timer / INTERVAL]);

		}

	} // end run

	/**
	 * 防御ダメージ
	 */
	public void damage(){
		timer = - INTERVAL * colors.length;
	}

}
